#!/usr/bin/perl
use CGI;
use vars qw($EOL $tcpproto $id $host $dont $query $defhost $nsihost $VERSION);
use Socket;
use Carp;
use integer;
$co = new CGI;
#@whoissites =
#("whois.arin.net","whois.geektools.com","whois.apnic.net","whois.ripe.net","whois.verio.net"
#);

my $nport = 43;
my $ans;
my $notdone = 1;

#####################################################
# Attempt to read a line safely from SOCK filehandle.
sub saferead () {
  my $line;
  eval {
        local$SIG{ALRM} = sub { die 'timeout!' };
        alarm 15;
        $line = <SOCK>;
        alarm 0;
       };
  if ($@ and $@ !~ /timeout!/) {warn("during socket read: $@",co->p)
	}
  return $line;
} # end &saferead 

#####################################################
# Print an error message
sub err404 ($$) {
	my $server_mess   = shift;
	my $internal_mess = shift;


  print "An error occured: $internal_mess\n";
  if ($server_mess ne 'unknown') {
    print  "Error continued: $server_mess\n";
  }
  return '';
} # end &err404 

#####################################################
# Grab an html page. Needs a remote hostname, a port number
# a first line request (eg "GET / HTTP/1.0"), and the remainder
# of the request (empty string if HTTP/0.9).
sub grab ($$$$) {
  my ($remote, $port, $request, $heads) = @_;
  my ($iaddr, $paddr, $line);
  my $out = '';
  my $len;
  my $rc;


  if (!($iaddr = inet_aton($remote))) { 
    return &err404('unknown',"no host: $remote");
  }
  $paddr   = sockaddr_in($port, $iaddr);

  if (!socket(SOCK, PF_INET, SOCK_STREAM, $tcpproto)) {
    return &err404('unknown', "socket: $!");
  }
  if (!connect(SOCK, $paddr)) {
    return &err404('unknown', "connect: $!");
  }

  $len = length($$request);
  $rc = syswrite(SOCK, $$request, $len);

  if ($rc != $len) {
    warn("request write to $remote was short ($rc != $len)\n");
    print ("Warning: request write to $remote was short ($rc != $len)<br>");

  } else {
    $len = length($$heads);
    $rc = syswrite(SOCK, $$heads, $len);

    warn("heads write to $remote was short ($rc != $len)\n")
        if ($rc != length($$heads));
  }

  while ($line = &saferead()) {
    $out .= $line;
    last if ($line =~ /^\015?\012?$/);
  }

  if ($out =~ /\nContent-Length:\s+(\d+)/) {
    read(SOCK,$out,$1,length($out));
  } else {

    # Back to line by line mode.
    while (defined($line = <SOCK>)) {
	print ($line,$co->br);
      $out .= $line;
    }
  }

  close (SOCK)            || die "close: $!";
  return $out;
} # end &grab


print $co->header,$co->start_html('Address Block Lookup Utility'),'Enter an IP Address or rdns domain name',
$co->	start_form,'Address: ',$co->textfield('addr2'),'Query the server for:',$co->textfield('extra'),$co->submit, $co->end_form,$co->hr;

$file = '/var/www/cgi-bin/addressblock.lst';  # must be readable by your webserver's user
open (FILE,$file) or warn "cannot open $file for reading and appending: $!";
@rawdata = <FILE>;
close(FILE);

#print ($co->hr);

#foreach $range (@rawdata) {
#	print (" $range <br>");
#	}
#print ($co->hr);


print ('If a link fails, do not report it to the respective sites.  Report it to <a href=mailto:joejared@osirusoft.com>me</a><br>');

if ($co->param()) {
	$test = $co->param('addr2');
	$xtradata = $co->param('extra');
	$xtralen = length($xtradata);
	$test =~ s/ +//g;
	
	$xtra2 = $xtradata;
	$xtra2 =~ s/ +/\%20/g;
	print ("The URL for this lookup is <a href=http://relays.osirusoft.com/cgi-bin/addressblock.cgi?addr2=$test&extra=$xtra2>http://relays.osirusoft.com/cgi-bin/addressblock.cgi?addr2=$test&extra=$xtra2</a><br>");
	
	$inarpa = gethostbyname($test);
	if ($? &255 ){($a,$b,$c,$d) = split ('\x2e',$test,4);}
else {($a,$b,$c,$d) = unpack ('C4',$inarpa);
print ('Resolved ',$test,' to ',$a,'.',$b,'.',$c,'.',$d,$co->p);
$test = join (".",$a,$b,$c,$d);

}


	($a,$b,$c,$d) = split ('\x2e',$test,4);
	$addrtest = ($a<<24) +($b<<16) +($c<<8)+ $d;
#	print ("$test $addrtest $a $b $c $d",$co->br);
	print ("<a href=rbcheck.cgi?addr=$a.$b.$c.$d>Is $a.$b.$c.$d listed by anyone?</a><br>");

	$EOL = "\cm\cj";

	$tcpproto = getprotobyname('tcp');
	$dont = 0;
	$host = '';
	$defhost = 'rs.internic.net';
	$nsihost = 'whois.networksolutions.com';
	
	$blockdefined = 0;

	foreach $range(@rawdata) {
			($addr,$netblock) = split (" ",$range);
			if ($addr != "") {
			
			($adbase,$blk) = split('/',$addr);
			($w,$x,$y,$z) = split ('\x2e',$adbase,4);


			$abase = ($w <<24)+($x<<16)+($y<<8)+($z);

			$maskoff = ((1 << (32-$blk))-1);
			$maskon = (-1 ^$maskoff) &0xffffffff;
			$a1 = ($abase & $maskon);
			$a2 = $abase | $maskoff;

			if ( ($addrtest>=$a1) && ($addrtest<=$a2)) {
				$blockdefined++;
				print ("<a href=rbcheck.cgi?addr=$w.$x.$y.$z>Is this network listed by anyone?</a><br>");
				print ($co->hr);
				($whoissite,$whoport ) = split (':',$netblock);
				$whoport= $whoport & 0xffff;
				if ($whoport eq 0) {$whoport=$nport;}
				print ("Associated netblock ( $addr ) is managed by $whoissite on port $whoport <br>");
				print ("Checking $whoissite for [ $test ]",$co->p);
					$notdone =1;
					while ($notdone) {

  					# Fetch the page

					
		  			if ($xtralen>0) {
		  				$ans = &grab($whoissite, $whoport, \$xtradata , \$EOL);
		  				}
		  			else { $ans = &grab($whoissite, $whoport, \$test, \$EOL);}
		  			
		  			
					$notdone = 0;
					};


					
	 	 	if (!$dont and $ans =~ /\s+Whois\s+Server[:\s]+((?:[\w-]+\.)+\w+)\s/) {
	  	 		$query = $1;  
	  			} else {
			
				$j = length($ans);
				print ( $j, " Characters received ",$co->p);

				@answers = 	split('\x0a',$ans);
				foreach $line(@answers) {


					@words = split('\x20',$line);
					foreach $word(@words) {
						if( $word =~ '\(' ) {
							$xtra2 = $word;
							$xtra2 =~ s/\)+//g;
							$xtra2 =~ s/\(+//g;
							$xtra2 =~ s/ +/\%20/g;
							print ("<a href=http://relays.osirusoft.com/cgi-bin/addressblock.cgi?addr2=$test&extra=$xtra2>$word</a> ");
							}
											
						else {		
							if( $word =~ '@' ) {
									print ("<a href=mailto:$word>$word</a> ");
									$nextnetname = false;
								} 
							
							else { 
								$nextnetname = false;
								print ($word,' ')};
								}
							}
				
					print('<br>');
					}

				}

			}
	
		}
	}
	if ($blockdefined ==0) {
		print ("This address space is undefined.  The current ipv4 assignments are available <a href=http://www.iana.org/assignments/ipv4-address-space>here</a><br>");	
		print ("If you believe this search to be in error, please email <a href=mailto:joejared@osirusoft.com>Joe Jared</a><br>");
		print ("The current list of identified networks can be found <a href=/addressblock.lst>Here</a>.");
		}
	}


print ($co->hr);
print ('If you have another source of testing you would like added, Please email <a href=mailto:joejared@osirusoft.com> Joe Jared</a>.',$co->p);


print end_html;

sub THEEND {
  my $signame = (shift or '(unknown)');
  die "Got SIG$signame ... exiting\n";
} # &THEEND

$SIG{INT}  = 'main::THEEND';
$SIG{TERM} = 'main::THEEND';
